# -*- coding: utf-8 -*-
"""
Created on Sun Dec  1 12:53:28 2019

@author: Vikram Khanna
"""

from __future__ import print_function
import numpy as np
import os
import glob
import matplotlib.pyplot as plt
import scipy.optimize as optimization

###############################################################################
path=os.getcwd() #get cwd path
##path=os.path.dirname(pathX) 
###############################################################################
def file2array(FileName):
    """
    function:
        file2array
    arguments:
        FileName, the name of the file to be read (including the path: in case it is not in the cwd)
    returns:
        fileData, the numpy array (N_lines-1,N_words) here (24,3), columns: N, U, Iters
        UMin, the minimum energy value
    """
    print("READING FILE...")  
    f=open(FileName,'r')         
    print("READING LINES...")
    lines=f.read().splitlines()        
    f.close()
    
    N_lines=int(len(lines))  				
    N_words=int(len(lines[1].split()))
    
    print("INPUT LINES IN NUMPY ARRAY...")
    print(N_lines,N_words)
    fileData=np.zeros((N_lines-1,N_words)) #Leaving first line which contain header
    for i in range(1,N_lines,1):
        fileData[i-1]=lines[i].split()
 
    return fileData

def Settingfile2array(FileName):
    """
    function:
        file2array
    arguments:
        FileName, the name of the file to be read (including the path: in case it is not in the cwd)
    returns:
        fileData, the numpy array (N_lines-1,N_words) here (24,3), columns: N, U, Iters
        UMin, the minimum energy value
    """
    print("READING FILE...")  
    f=open(FileName,'r')         
    print("READING LINES...")
    lines=f.read().splitlines()        
    f.close()
    
    N_lines=int(len(lines))  				
#    N_words=int(len(lines[1].split()))
    
    print("INPUT LINES IN NUMPY ARRAY...")
#    print(N_lines,N_words)
    fileData=np.zeros((N_lines,1)) #Leaving first line which contain header
    for i in range(0,N_lines,1):
        fileData[i]=(lines[i].split())[-1]
 
    return fileData
###############################################################################

M_val=[1]


lmb_val=45






print("lmb: ", (lmb_val))            
FileName=r'lmbda_pt_%s'%str(lmb_val)+r'\EqmRun.txt' 
fileData= file2array(FileName)

FileNameSettings=r'lmbda_pt_%s'%str(lmb_val)+r'\SettingsEqmRun.txt' 
fileDataSettings = Settingfile2array(FileNameSettings)
NPoly=float(fileDataSettings[3])
N=float(fileDataSettings[5])
L=float(fileDataSettings[6])
V=L**3
print(V)
MCSweep=fileData[:,0]/N
U=fileData[:,2]

CutVal=int(5000)
StepVal=int(1)

U=U[CutVal::StepVal]
print("Avg U: ",np.mean(U))
print("Std U: ",np.std(U))
###############################################################################

#U_i = U[1:]
#U_i_minus_1 = U[:-1]
#
#print(np.corrcoef(U_i_minus_1,U_i)[0,1])
#
#
#plt.plot(U_i_minus_1,U_i,'bo')    
#axes = plt.gca()
##xMin, xMax = axes.get_xlim()
#xLine = np.linspace(*axes.get_xlim())
#axes.plot(xLine, xLine)
#
################################################################################
#
"""
autocorrelation=[]

for shift in range(0,1000,1):
    if shift==0:
        shift=None
        minus_shift=None
    else:
        minus_shift=-shift
    x=U[:minus_shift]
    y=U[shift:]
    correlation = np.corrcoef(x,y)[0,1]
    autocorrelation.append(correlation)

plt.figure()
plt.plot(range(0,1000,1),autocorrelation,'bo')   
#plt.xlabel(r'number density ($\rho$)',fontsize=35)
#plt.ylabel(r'Pressure ($P$)',fontsize=35)
plt.xticks(fontsize=35)
plt.yticks(fontsize=35)
plt.axhline(0, color='black') 
plt.axvline(0, color='black') 
#plt.legend(("M=1","M=2","M=4"),fontsize=35,loc=2)
###############################################################################

A=U
print(len(U))
var_A = np.var(A)
def C(A,shift):
    if shift==0:
        shift=None
        minus_shift=None
    else:
        minus_shift=-shift
        
#    print(shift,len(A[:minus_shift]))

    avg_A0=np.mean(A[:minus_shift])
    Ca_t=(np.mean(A[shift:]*A[:minus_shift])-(avg_A0*avg_A0))/var_A
    return Ca_t

autocorrelation2=[]
for shift in range(0,1000,1):
    autocorrelation2.append(C(A,shift))
#plt.figure()
plt.plot(range(0,1000,1),autocorrelation2,'ro')   
plt.xticks(fontsize=35)
plt.yticks(fontsize=35)
plt.axhline(0, color='black') 
plt.axvline(0, color='black') 
"""
###############################################################################  
sigma_Ai=[]
t_tot=[]  
for l in range(100,1200,1):
    numOfData=len(U)
    sigma_A=np.var(U)
    numberOfBlocks=numOfData//l
    trimEdge=numOfData%l
    avg_Ai = []
    
    print("Length of block: ", l, " Number of blocks: ", numberOfBlocks)
    for j in range(numberOfBlocks):
        avg_Ai.append(np.mean(U[j*l:(j+1)*l]))
    sigma_Ai.append(np.var(avg_Ai))
    t_tot.append(l)

sigma_Ai=np.array(sigma_Ai)
t_tot=np.array(t_tot)
x=sigma_A/t_tot
y=sigma_Ai

plt.figure()
ax=plt.gca()
plt.plot(x,y,'bo')        
m,c=np.polyfit(x,y,1)
print(m,c)
plt.plot(x,m*x+c,'k--')
plt.xticks(fontsize=35)
plt.yticks(fontsize=35)
plt.xlabel(r'$\sigma_{A}^2/t_{tot}$',fontsize=35)
plt.ylabel(r'$\sigma_{A_i}^2$',fontsize=35)
plt.text(0.8,0.2,r'$2\tau_A$=%s'%str(round(m,2)),transform=ax.transAxes,fontsize=20)
plt.axhline(0, color='black') 
plt.axvline(0, color='black') 
