# -*- coding: utf-8 -*-
"""
Created on Sun Nov 24 20:10:55 2019

@author: Vikram Khanna
"""

import sys
#sys.path.append(r'C:\Users\Vikram Khanna\Documents\Docs_Vikram\Docs_US\UCSB_Books\Python_Learning\processing_distributions')
import numpy as np
import os
import matplotlib.pyplot as plt
import random

path=os.getcwd() #get cwd path
##path=os.path.dirname(pathX) 
###############################################################################
def file2array(FileName):
    """
    function:
        file2array
    arguments:
        FileName, the name of the file to be read (including the path: in case it is not in the cwd)
    returns:
        fileData, the numpy array (N_lines-1,N_words) here (24,3), columns: N, U, Iters
        UMin, the minimum energy value
    """
    print("READING FILE...")  
    f=open(FileName,'r')         
    print("READING LINES...")
    lines=f.read().splitlines()        
    f.close()
    print 'Header is: ',lines[0]
    N_lines=int(len(lines))  				
    N_words=int(len(lines[1].split()))
    
    print("INPUT LINES IN NUMPY ARRAY...")
    print(N_lines,N_words)
    fileData=np.zeros((N_lines-1,N_words)) #Leaving first line which contain header
    for i in range(1,N_lines,1):
        fileData[i-1]=lines[i].split()
 
    return fileData
###############################################################################

def Settingfile2array(FileName):
    """
    function:
        file2array
    arguments:
        FileName, the name of the file to be read (including the path: in case it is not in the cwd)
    returns:
        fileData, the numpy array (N_lines-1,N_words) here (24,3), columns: N, U, Iters
        UMin, the minimum energy value
    """
    print("READING FILE...")  
    f=open(FileName,'r')         
    print("READING LINES...")
    lines=f.read().splitlines()        
    f.close()
    
    N_lines=int(len(lines))  				
#    N_words=int(len(lines[1].split()))
    
    print("INPUT LINES IN NUMPY ARRAY...")
#    print(N_lines,N_words)
    fileData=np.zeros((N_lines,1)) #Leaving first line which contain header
    for i in range(0,N_lines,1):
        fileData[i]=(lines[i].split())[-1]
 
    return fileData

FileNameSettings=r'lmbda_pt_1'+r'\SettingsEqmRun.txt' 
fileDataSettings = Settingfile2array(FileNameSettings)
N=float(fileDataSettings[5])
T=float(fileDataSettings[2])
###############################################################################
lmb=np.array([6.98177409e-04, 3.67500078e-03, 9.01564248e-03, 1.66958448e-02,
       2.66791545e-02, 3.89180316e-02, 5.33541641e-02, 6.99187620e-02,
       8.85328897e-02, 1.09107844e-01, 1.31545576e-01, 1.55739160e-01,
       1.81573303e-01, 2.08924894e-01, 2.37663590e-01, 2.67652438e-01,
       2.98748528e-01, 3.30803673e-01, 3.63665115e-01, 3.97176255e-01,
       4.31177397e-01, 4.65506510e-01, 5.00000000e-01, 5.34493490e-01,
       5.68822603e-01, 6.02823745e-01, 6.36334885e-01, 6.69196327e-01,
       7.01251472e-01, 7.32347562e-01, 7.62336410e-01, 7.91075106e-01,
       8.18426697e-01, 8.44260840e-01, 8.68454424e-01, 8.90892156e-01,
       9.11467110e-01, 9.30081238e-01, 9.46645836e-01, 9.61081968e-01,
       9.73320845e-01, 9.83304155e-01, 9.90984358e-01, 9.96324999e-01,
       9.99301823e-01])

lmb_sorted=lmb

def generateSample(s):
    numOfData=len(s)
    sample0=[]
    ######################################
    ##   randomly sample with replacement
    for i in range(numOfData):
        sample0.append(random.sample(s,1))
    ######################################
    sample0=np.array(sample0)
    sample0=sample0.reshape((numOfData,))
    return sample0

def BootStrap(s,numOfSample):
    X=[]
    for i in range(numOfSample):
        sample=generateSample(s)
        X.append(F(sample))
    meanX=np.mean(X)
    semX=np.std(X)
    
    return meanX,semX


def F(sample):
    return np.mean(sample)


dUdl_arr=[]
dUdl_err_arr=[]

for i in range(len(lmb_sorted)):
    FileName=r'lmbda_pt_%s'%str(i+1)+r'\EqmRun.txt'
    fileData=file2array(FileName)
    dUdl = (fileData[:,2])
    
    CutVal=50000#swwps,since dumping every 100N
    dUdl=dUdl[CutVal::15]


    print "No. of data pts used: ", len(dUdl)
    
    numOfSample=200 #for Bootstrapping 
    
    meanX,semX=BootStrap(dUdl,numOfSample) #bootstrapped mean and std err. in mean
    
    dUdl_arr.append(meanX)
    dUdl_err_arr.append(semX)


dUdl_arr=np.array(dUdl_arr)
dUdl_err_arr=np.array(dUdl_err_arr)


###############################################################################

def get_wts(pts,a,b):
    [nodes,wts]=np.polynomial.legendre.leggauss(pts)

    # Calc nodes and wts. for integration limits a to b

#    a=0.75
#    b=1.00

    nodes_new=np.zeros(len(nodes))
    wts_new=np.zeros(len(nodes))

    ctr=0
    for i in range(len(nodes)):
        nodes_new[ctr]=((b-a)/2.0)*nodes[ctr] + (b+a)/2.0
        wts_new[ctr] = ((b-a)/2.0)*wts[ctr]
        ctr=ctr+1
    
    return wts_new    

###############################################################################

LB=0
UB=None


a=0.00
b=1.00
wts=get_wts(len(lmb),a,b)

def gaussian_intg(wts,fx):
    W_Quad=0.0
    W_Quad=np.sum(np.multiply(wts,fx))
    return W_Quad

def gaussian_intg_err(wts,dfx):
    wts_sq=wts*wts
    dfx_sq=dfx*dfx
    W_Quad_error=np.sqrt(np.sum(np.multiply(wts_sq,dfx_sq)))
    return W_Quad_error


res_sorted=dUdl_arr
res_err_sorted=dUdl_err_arr

WQuad1=gaussian_intg(wts,res_sorted+res_err_sorted)
WQuad2=gaussian_intg(wts,res_sorted-res_err_sorted)

WGaussQuad=gaussian_intg(wts,res_sorted)
WGaussQuad_err=gaussian_intg_err(wts,res_err_sorted)
print "##########################################"
print "no of points", len(lmb_sorted)
print 'Quads', WGaussQuad, " +- ",(WQuad1-WQuad2)  
print 'Quads_NEW', WGaussQuad, " +- ",WGaussQuad_err

###############################################################################   
plt.figure()
plt.errorbar(lmb_sorted,res_sorted,res_err_sorted,ls='--',marker='o')
#plt.plot(lmb_sorted,res_sorted)
plt.ticklabel_format(useOffset=False, style='plain')
plt.xlim(0,1)
plt.xlabel(r'$\lambda$', fontsize =36)
plt.ylabel(r'$<dU/d\lambda>_\lambda (N_{mol}kT)$', fontsize=36)
plt.rc('xtick', labelsize=30)
plt.rc('ytick', labelsize=20)
plt.tick_params(labelsize=28)

plt.axhline(0, color='black')
plt.axvline(0, color='black')
plt.fill_between(lmb_sorted,0,res_sorted,color='yellow')
plt.show()  

#plt.figure()
#plt.plot(dUdl)
###############################################################################   
fOutput=file(r'Results_MC.txt','w')
fOutput.write("%16s %16s %16s\n"%("lmb","dUdl", "error"))
for i in range(len(lmb_sorted)):
    fOutput.write("%16.8f %16.8f %16.8f\n"%(lmb_sorted[i], res_sorted[i], res_err_sorted[i]))
fOutput.close()
###############################################################################   
